import { IOptions, IField, Field } from 'wind-core';
export { Field } from 'wind-core';
import * as ol from 'openlayers';

interface IWindOptions extends IOptions {
    opacity?: number;
    map?: ol.Map;
    visible?: boolean;
    extent?: ol.Extent;
    minResolution?: number;
    maxResolution?: number;
    zIndex?: number;
    windOptions: Partial<IOptions>;
    fieldOptions: Partial<IField>;
    [key: string]: any;
}
declare class OlWind extends ol.layer.Image {
    private options;
    private canvas;
    private wind;
    private field;
    viewProjection: ol.ProjectionLike;
    pixelRatio: number;
    private type;
    constructor(data: any, options?: Partial<IWindOptions>);
    /**
     * append layer to map
     * @param map
     */
    appendTo(map: ol.Map): void;
    start(): void;
    stop(): void;
    canvasFunction(extent: ol.Extent, resolution: number, pixelRatio: number, size: ol.Size, proj: ol.proj.Projection): HTMLCanvasElement;
    private getContext;
    /**
     * render windy layer
     * @param canvas
     * @returns {OlWind}
     */
    private render;
    project(coordinate: [number, number]): [number, number];
    unproject(pixel: [number, number]): [number, number];
    /**
     * TODO: 空间判断出错，需要修复
     * @param coordinate
     */
    intersectsCoordinate(coordinate: [number, number]): boolean;
    private pickWindOptions;
    /**
     * get wind layer data
     */
    getData(): Field | undefined;
    /**
     * set layer data
     * @param data
     * @param options
     * @returns {OlWind}
     */
    setData(data: any, options?: Partial<IField>): this;
    updateParams(options?: Partial<IOptions>): this;
    getParams(): Partial<IOptions>;
    setWindOptions(options: Partial<IOptions>): void;
    getWindOptions(): Partial<IOptions>;
    private getProjection;
    /**
     * set map
     * @param map
     */
    setMap(map: ol.Map): void;
    /**
     * get map
     */
    getMap(): any;
    getType(): string;
}
declare const WindLayer: typeof OlWind;

export { type IWindOptions, WindLayer, OlWind as default };
